//------------------------------------------------------------------------------
//                    Delphi JBS Typed Controls package
//                               Version 2.0
//------------------------------------------------------------------------------
// This unit contents Property Editor for Typed Controls' 'PropertyName'
// properties. It allows You to choose Name of Property You want to assign to
// from the drop-down Value list.
//
// Contents:   TPropertyNameProperty  property editor
//
// Writen by  Jack Bars  {October 1998}
//
//------------------------------------------------------------------------------

unit PropertyNameProperty;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TypedComboBox, TypedEdit, TypedListBox, TypedCheckBox, TypedSpinEdit,
  TypedRadioGroup, TypedCheckListBox, TypedControlItemsProperty,
  DsgnIntf, TypInfo;

type

   TPropertyNameProperty = class(TStringProperty)
     public
       function GetAttributes: TPropertyAttributes; override;
       procedure GetValues(Proc: TGetStrProc); override;
   end;

procedure Register;


implementation


procedure TPropertyNameProperty.GetValues(Proc: TGetStrProc);
var
  i, Count: integer;
  PropList: PPropList;
begin
  if (GetComponent(0) is TTypedCheckListBox) then
    if ((GetComponent(0) as TTypedCheckListBox).Component = nil) then Exit;
  if (GetComponent(0) is TTypedRadioGroup) then
    if ((GetComponent(0) as TTypedRadioGroup).Component = nil) then Exit;
  if (GetComponent(0) is TTypedSpinEdit) then
    if ((GetComponent(0) as TTypedSpinEdit).Component = nil) then Exit;
  if (GetComponent(0) is TTypedEdit) then
    if ((GetComponent(0) as TTypedEdit).Component = nil) then Exit;
  if (GetComponent(0) is TTypedCheckBox) then
    if ((GetComponent(0) as TTypedCheckBox).Component = nil) then Exit;
  if (GetComponent(0) is TTypedComboBox) then
    if ((GetComponent(0) as TTypedComboBox).Component = nil) then Exit;
  if (GetComponent(0) is TTypedListBox) then
    if ((GetComponent(0) as TTypedListBox).Component = nil) then Exit;


  if (GetComponent(0) is TTypedRadioGroup) then
  begin
    Count := GetPropList(((GetComponent(0) as TTypedRadioGroup).Component).ClassInfo, [tkEnumeration], nil);
    GetMem(PropList, Count * SizeOf(PPropInfo));
    try
      GetPropList(((GetComponent(0) as TTypedRadioGroup).Component).ClassInfo, [tkEnumeration], PropList);
      for i := 0 to Count - 1 do
        Proc((PropList^[i])^.Name);
    finally
      FreeMem(PropList, Count * SizeOf(PPropList));
    end;
  end
  else

  if (GetComponent(0) is TTypedComboBox) then
  begin
    Count := GetPropList(((GetComponent(0) as TTypedComboBox).Component).ClassInfo, [tkEnumeration], nil);
    GetMem(PropList, Count * SizeOf(PPropInfo));
    try
      GetPropList(((GetComponent(0) as TTypedComboBox).Component).ClassInfo, [tkEnumeration], PropList);
      for i := 0 to Count - 1 do
        Proc((PropList^[i])^.Name);
    finally
      FreeMem(PropList, Count * SizeOf(PPropList));
    end;
  end
  else

  if (GetComponent(0) is TTypedCheckListBox) then
  begin
    Count := GetPropList(((GetComponent(0) as TTypedCheckListBox).Component).ClassInfo, [tkSet], nil);
    GetMem(PropList, Count * SizeOf(PPropInfo));
    try
      GetPropList(((GetComponent(0) as TTypedCheckListBox).Component).ClassInfo, [tkSet], PropList);
      for i := 0 to Count - 1 do
        if (GetTypeData((PropList^[i])^.PropType^)^.CompType^)^.Kind = tkEnumeration then
          Proc((PropList^[i])^.Name);
    finally
      FreeMem(PropList, Count * SizeOf(PPropList));
    end;
  end
  else

  if (GetComponent(0) is TTypedListBox) then
  begin
    Count := GetPropList(((GetComponent(0) as TTypedListBox).Component).ClassInfo, [tkEnumeration], nil);
    GetMem(PropList, Count * SizeOf(PPropInfo));
    try
      GetPropList(((GetComponent(0) as TTypedListBox).Component).ClassInfo, [tkEnumeration], PropList);
      for i := 0 to Count - 1 do
        Proc((PropList^[i])^.Name);
    finally
      FreeMem(PropList, Count * SizeOf(PPropList));
    end;
  end
  else

  if (GetComponent(0) is TTypedCheckBox) then
  begin
    Count := GetPropList(((GetComponent(0) as TTypedCheckBox).Component).ClassInfo, [tkEnumeration], nil);
    GetMem(PropList, Count * SizeOf(PPropInfo));
    try
      GetPropList(((GetComponent(0) as TTypedCheckBox).Component).ClassInfo, [tkEnumeration], PropList);
      for i := 0 to Count - 1 do
      if GetEnumName((PropList^[i])^.PropType^, (GetTypeData((PropList^[i])^.PropType^))^.MinValue) = 'False' then
        Proc((PropList^[i])^.Name);
    finally
      FreeMem(PropList, Count * SizeOf(PPropList));
    end;
  end
  else

  if (GetComponent(0) is TTypedEdit) then
  begin
    Count := GetPropList(((GetComponent(0) as TTypedEdit).Component).ClassInfo, [tkString, tkWString, tkLString], nil);
    GetMem(PropList, Count * SizeOf(PPropInfo));
    try
      GetPropList(((GetComponent(0) as TTypedEdit).Component).ClassInfo, [tkString, tkWString, tkLString], PropList);
      for i := 0 to Count - 1 do
        Proc((PropList^[i])^.Name);
    finally
      FreeMem(PropList, Count * SizeOf(PPropList));
    end;
  end
  else

  if (GetComponent(0) is TTypedSpinEdit) then
  begin
    Count := GetPropList(((GetComponent(0) as TTypedSpinEdit).Component).ClassInfo, [tkInteger], nil);
    GetMem(PropList, Count * SizeOf(PPropInfo));
    try
      GetPropList(((GetComponent(0) as TTypedSpinEdit).Component).ClassInfo, [tkInteger], PropList);
      for i := 0 to Count - 1 do
        Proc((PropList^[i])^.Name);
    finally
      FreeMem(PropList, Count * SizeOf(PPropList));
    end;
  end;

end;


function TPropertyNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes - [paMultiSelect] + [paValueList,paSortList];
end;


procedure Register;
begin
  RegisterComponents('JBS Typed Controls', [TTypedEdit, TTypedComboBox, TTypedListBox,
    TTypedCheckBox, TTypedSpinEdit, TTypedRadioGroup, TTypedCheckListBox]);
  RegisterPropertyEditor(TypeInfo(string), TTypedComboBox, 'PropertyName', TPropertyNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTypedListBox, 'PropertyName', TPropertyNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTypedCheckBox, 'PropertyName', TPropertyNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTypedEdit, 'PropertyName', TPropertyNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTypedSpinEdit, 'PropertyName', TPropertyNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTypedRadioGroup, 'PropertyName', TPropertyNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TTypedCheckListBox, 'PropertyName', TPropertyNameProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TTypedComboBox, 'Items', TTypedControlItemsProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TTypedListBox, 'Items', TTypedControlItemsProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TTypedRadioGroup, 'Items', TTypedControlItemsProperty);
  RegisterPropertyEditor(TypeInfo(TStrings), TTypedCheckListBox, 'Items', TTypedControlItemsProperty);
end;


end.

