//------------------------------------------------------------------------------
//                    Delphi JBS Typed Controls package
//                               Version 2.0
//------------------------------------------------------------------------------
// This unit contents Property Editor for Typed Controls' 'Items' properties.
// It allows You to see Typed Controls' Items in a Small Window. This one Made
// to prohibit Items poperty's value changing.
//
// Contents:   TTypedControlsItemsProperty  property editor
//
// Writen by  Jack Bars  {October 1998}
//
//------------------------------------------------------------------------------

unit TypedControlItemsProperty;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, TypedComboBox, TypedRadioGroup, TypedListBox,
  TypedCheckListBox, DsgnIntf, Buttons;

type

  TTypedControlItemsPropertyForm = class(TForm)
    Panel: TPanel;
    lbItems: TListBox;
    BitBtn1: TBitBtn;
    procedure HemisphereButton1Click(Sender: TObject);
  private
   { Private declarations }
  public
   { Public declarations }
  end;

  TTypedControlItemsProperty = class(TPropertyEditor)
     public
       function GetAttributes: TPropertyAttributes; override;
       procedure Edit; override;
       function GetValue: string; override;
  end;

var
  TypedControlItemsPropertyForm: TTypedControlItemsPropertyForm;

implementation

{$R *.DFM}

function TTypedControlItemsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes - [paMultiSelect] + [paDialog];
end;


procedure TTypedControlItemsProperty.Edit;
var
  fmTypedControl: TTypedControlItemsPropertyForm;
  i: LongInt;
begin
  if (GetComponent(0) is TTypedCheckListBox) then
    if ((GetComponent(0) as TTypedCheckListBox).Component = nil) then Exit;
   if (GetComponent(0) is TTypedRadioGroup) then
    if ((GetComponent(0) as TTypedRadioGroup).Component = nil) then Exit;
  if (GetComponent(0) is TTypedComboBox) then
    if ((GetComponent(0) as TTypedComboBox).Component = nil) then Exit;
  if (GetComponent(0) is TTypedListBox) then
    if ((GetComponent(0) as TTypedListBox).Component = nil) then Exit;

  fmTypedControl := TTypedControlItemsPropertyForm.Create(Application);
  with fmTypedControl do
  begin
      lbItems.Clear;

    if (GetComponent(0) is TTypedCheckListBox) then
    for i := 0 to (GetComponent(0) as TTypedCheckListBox).Items.Count - 1 do
      lbItems.Items.Add((GetComponent(0) as TTypedCheckListBox).Items[i]);

    if (GetComponent(0) is TTypedRadioGroup) then
    for i := 0 to (GetComponent(0) as TTypedRadioGroup).Items.Count - 1 do
      lbItems.Items.Add((GetComponent(0) as TTypedRadioGroup).Items[i]);

    if (GetComponent(0) is TTypedComboBox) then
    for i := 0 to (GetComponent(0) as TTypedComboBox).Items.Count - 1 do
      lbItems.Items.Add((GetComponent(0) as TTypedComboBox).Items[i]);

    if (GetComponent(0) is TTypedListBox) then
    for i := 0 to (GetComponent(0) as TTypedListBox).Items.Count - 1 do
      lbItems.Items.Add((GetComponent(0) as TTypedListBox).Items[i]);

    try
      ShowModal;
    finally
      Free;
    end;
  end;
end;


function TTypedControlItemsProperty.GetValue: string;
begin
  Result := '(TStrings)';
end;


procedure TTypedControlItemsPropertyForm.HemisphereButton1Click(
  Sender: TObject);
begin
  ModalResult := mrOk;
end;


end.
